Index: serefpolicy-contrib-20140730/postfix.if
===================================================================
--- serefpolicy-contrib-20140730.orig/postfix.if
+++ serefpolicy-contrib-20140730/postfix.if
@@ -1,4 +1,4 @@
-## <summary>Postfix email server.</summary>
+## <summary>Postfix email server</summary>
 
 ########################################
 ## <summary>
@@ -16,13 +16,14 @@ interface(`postfix_stub',`
 	')
 ')
 
-#######################################
+########################################
 ## <summary>
-##	The template to define a postfix domain.
+##	Creates types and rules for a basic
+##	postfix process domain.
 ## </summary>
-## <param name="domain_prefix">
+## <param name="prefix">
 ##	<summary>
-##	Domain prefix to be used.
+##	Prefix for the domain.
 ##	</summary>
 ## </param>
 #
@@ -31,73 +32,69 @@ template(`postfix_domain_template',`
 		attribute postfix_domain;
 	')
 
-	########################################
-	#
-	# Declarations
-	#
-
 	type postfix_$1_t, postfix_domain;
 	type postfix_$1_exec_t;
 	domain_type(postfix_$1_t)
 	domain_entry_file(postfix_$1_t, postfix_$1_exec_t)
 	role system_r types postfix_$1_t;
 
-	########################################
-	#
-	# Policy
-	#
-
-	can_exec(postfix_$1_t, postfix_$1_exec_t)
+	kernel_read_system_state(postfix_$1_t)
 
 	auth_use_nsswitch(postfix_$1_t)
+
+	logging_send_syslog_msg(postfix_$1_t)
+
+	can_exec(postfix_$1_t, postfix_$1_exec_t)
 ')
 
-#######################################
+########################################
 ## <summary>
-##	The template to define a postfix server domain.
+##	Creates a postfix server process domain.
 ## </summary>
-## <param name="domain_prefix">
+## <param name="prefix">
 ##	<summary>
-##	Domain prefix to be used.
+##	Prefix of the domain.
 ##	</summary>
 ## </param>
 #
 template(`postfix_server_domain_template',`
-	gen_require(`
-		attribute postfix_server_domain, postfix_server_tmp_content;
-	')
-
-	########################################
-	#
-	# Declarations
-	#
-
 	postfix_domain_template($1)
 
-	typeattribute postfix_$1_t postfix_server_domain;
-
-	type postfix_$1_tmp_t, postfix_server_tmp_content;
+	type postfix_$1_tmp_t;
 	files_tmp_file(postfix_$1_tmp_t)
 
-	########################################
-	#
-	# Declarations
-	#
+	allow postfix_$1_t self:capability { setuid setgid sys_chroot dac_override };
+	allow postfix_$1_t postfix_master_t:unix_stream_socket { connectto rw_stream_socket_perms };
+	allow postfix_$1_t self:tcp_socket create_socket_perms;
+	allow postfix_$1_t self:udp_socket create_socket_perms;
 
 	manage_dirs_pattern(postfix_$1_t, postfix_$1_tmp_t, postfix_$1_tmp_t)
 	manage_files_pattern(postfix_$1_t, postfix_$1_tmp_t, postfix_$1_tmp_t)
 	files_tmp_filetrans(postfix_$1_t, postfix_$1_tmp_t, { file dir })
 
 	domtrans_pattern(postfix_master_t, postfix_$1_exec_t, postfix_$1_t)
+
+	corenet_all_recvfrom_netlabel(postfix_$1_t)
+	corenet_tcp_sendrecv_generic_if(postfix_$1_t)
+	corenet_udp_sendrecv_generic_if(postfix_$1_t)
+	corenet_tcp_sendrecv_generic_node(postfix_$1_t)
+	corenet_udp_sendrecv_generic_node(postfix_$1_t)
+	corenet_tcp_sendrecv_all_ports(postfix_$1_t)
+	corenet_udp_sendrecv_all_ports(postfix_$1_t)
+	corenet_tcp_bind_generic_node(postfix_$1_t)
+	corenet_udp_bind_generic_node(postfix_$1_t)
+	corenet_tcp_connect_all_ports(postfix_$1_t)
+	corenet_sendrecv_all_client_packets(postfix_$1_t)
 ')
 
-#######################################
+########################################
 ## <summary>
-##	The template to define a postfix user domain.
+##	Creates a process domain for programs
+##	that are ran by users.
 ## </summary>
-## <param name="domain_prefix">
+## <param name="prefix">
 ##	<summary>
-##	Domain prefix to be used.
+##	Prefix of the domain.
 ##	</summary>
 ## </param>
 #
@@ -106,30 +103,22 @@ template(`postfix_user_domain_template',
 		attribute postfix_user_domains, postfix_user_domtrans;
 	')
 
-	########################################
-	#
-	# Declarations
-	#
-
 	postfix_domain_template($1)
 
 	typeattribute postfix_$1_t postfix_user_domains;
 
-	########################################
-	#
-	# Policy
-	#
-
 	allow postfix_$1_t self:capability dac_override;
 
 	domtrans_pattern(postfix_user_domtrans, postfix_$1_exec_t, postfix_$1_t)
 
 	domain_use_interactive_fds(postfix_$1_t)
+
+	application_domain(postfix_$1_t, postfix_$1_exec_t)
 ')
 
 ########################################
 ## <summary>
-##	Read postfix configuration content.
+##	Read postfix configuration files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -143,16 +132,15 @@ interface(`postfix_read_config',`
 		type postfix_etc_t;
 	')
 
+	read_files_pattern($1, postfix_etc_t, postfix_etc_t)
+	read_lnk_files_pattern($1, postfix_etc_t, postfix_etc_t)
 	files_search_etc($1)
-	allow $1 postfix_etc_t:dir list_dir_perms;
-	allow $1 postfix_etc_t:file read_file_perms;
-	allow $1 postfix_etc_t:lnk_file read_lnk_file_perms;
 ')
 
 ########################################
 ## <summary>
-##	Create specified object in postfix
-##	etc directories with a type transition.
+##	Create files with the specified type in
+##	the postfix configuration directories.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -180,6 +168,7 @@ interface(`postfix_config_filetrans',`
 		type postfix_etc_t;
 	')
 
+	files_search_etc($1)
 	filetrans_pattern($1, postfix_etc_t, $2, $3, $4)
 ')
 
@@ -205,7 +194,8 @@ interface(`postfix_dontaudit_rw_local_tc
 
 ########################################
 ## <summary>
-##	Read and write postfix local pipes.
+##	Allow read/write postfix local pipes
+##	TCP sockets.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -221,30 +211,28 @@ interface(`postfix_rw_local_pipes',`
 	allow $1 postfix_local_t:fifo_file rw_fifo_file_perms;
 ')
 
-########################################
+#######################################
 ## <summary>
-##	Read postfix local process state files.
+##  Allow read/write postfix public pipes
+##  TCP sockets.
 ## </summary>
 ## <param name="domain">
-##	<summary>
-##	Domain allowed access.
-##	</summary>
+##  <summary>
+##  Domain allowed access.
+##  </summary>
 ## </param>
 #
-interface(`postfix_read_local_state',`
-	gen_require(`
-		type postfix_local_t;
-	')
+interface(`postfix_rw_public_pipes',`
+    gen_require(`
+        type postfix_public_t;
+    ')
 
-	kernel_search_proc($1)
-	allow $1 postfix_local_t:dir list_dir_perms;
-	allow $1 postfix_local_t:file read_file_perms;
-	allow $1 postfix_local_t:lnk_file read_lnk_file_perms;
+    allow $1 postfix_public_t:fifo_file rw_fifo_file_perms;
 ')
 
 ########################################
 ## <summary>
-##	Read and write inherited postfix master pipes.
+##	Allow domain to read postfix local process state
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -252,18 +240,18 @@ interface(`postfix_read_local_state',`
 ##	</summary>
 ## </param>
 #
-interface(`postfix_rw_inherited_master_pipes',`
+interface(`postfix_read_local_state',`
 	gen_require(`
-		type postfix_master_t;
+		type postfix_local_t;
 	')
 
-	allow $1 postfix_master_t:fd use;
-	allow $1 postfix_master_t:fifo_file { getattr write append lock ioctl read };
+	kernel_search_proc($1)
+	ps_process_pattern($1, postfix_local_t)
 ')
 
 ########################################
 ## <summary>
-##	Read postfix master process state files.
+##	Allow domain to read postfix master process state
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -277,14 +265,13 @@ interface(`postfix_read_master_state',`
 	')
 
 	kernel_search_proc($1)
-	allow $1 postfix_master_t:dir list_dir_perms;
-	allow $1 postfix_master_t:file read_file_perms;
-	allow $1 postfix_master_t:lnk_file read_lnk_file_perms;
+	ps_process_pattern($1, postfix_master_t)
 ')
 
 ########################################
 ## <summary>
-##	Use postfix master file descriptors.
+##	Use postfix master process file
+##	file descriptors.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -335,15 +322,13 @@ interface(`postfix_domtrans_map',`
 		type postfix_map_t, postfix_map_exec_t;
 	')
 
-	corecmd_search_bin($1)
 	domtrans_pattern($1, postfix_map_exec_t, postfix_map_t)
 ')
 
 ########################################
 ## <summary>
-##	Execute postfix map in the postfix
-##	map domain, and allow the specified
-##	role the postfix_map domain.
+##	Execute postfix_map in the postfix_map domain, and
+##	allow the specified role the postfix_map domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -359,17 +344,17 @@ interface(`postfix_domtrans_map',`
 #
 interface(`postfix_run_map',`
 	gen_require(`
-		attribute_role postfix_map_roles;
+		type postfix_map_t;
 	')
 
 	postfix_domtrans_map($1)
-	roleattribute $2 postfix_map_roles;
+	role $2 types postfix_map_t;
 ')
 
 ########################################
 ## <summary>
-##	Execute the master postfix program
-##	in the postfix_master domain.
+##	Execute the master postfix program in the
+##	postfix_master domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -380,16 +365,35 @@ interface(`postfix_run_map',`
 interface(`postfix_domtrans_master',`
 	gen_require(`
 		type postfix_master_t, postfix_master_exec_t;
+		attribute postfix_domain;
 	')
 
-	corecmd_search_bin($1)
 	domtrans_pattern($1, postfix_master_exec_t, postfix_master_t)
 ')
 
+
 ########################################
 ## <summary>
-##	Execute the master postfix program
-##	in the caller domain.
+##	Execute the master postfix in the postfix master domain.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`postfix_initrc_domtrans',`
+	gen_require(`
+		type postfix_initrc_exec_t;
+	')
+
+	init_labeled_script_domtrans($1, postfix_initrc_exec_t)
+')
+
+########################################
+## <summary>
+##	Execute the master postfix program in the
+##	caller domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -402,21 +406,18 @@ interface(`postfix_exec_master',`
 		type postfix_master_exec_t;
 	')
 
-	corecmd_search_bin($1)
 	can_exec($1, postfix_master_exec_t)
 ')
 
 #######################################
 ## <summary>
-##	Connect to postfix master process
-##	using a unix domain stream socket.
+##	Connect to postfix master process using a unix domain stream socket.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
 ##	Domain allowed access.
 ##	</summary>
 ## </param>
-## <rolecap/>
 #
 interface(`postfix_stream_connect_master',`
 	gen_require(`
@@ -428,8 +429,7 @@ interface(`postfix_stream_connect_master
 
 ########################################
 ## <summary>
-##	Read and write postfix master
-##	unnamed pipes.  (Deprecated)
+##	Allow read/write postfix master pipes
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -437,15 +437,18 @@ interface(`postfix_stream_connect_master
 ##	</summary>
 ## </param>
 #
-interface(`postfix_rw_master_pipes',`
-	refpolicywarn(`$0($*) has been deprecated, use postfix_rw_inherited_master_pipes() instead.')
-	postfix_rw_inherited_master_pipes($1)
+interface(`postfix_rw_inherited_master_pipes',`
+	gen_require(`
+		type postfix_master_t;
+	')
+
+	allow $1 postfix_master_t:fifo_file rw_inherited_fifo_file_perms;
 ')
 
 ########################################
 ## <summary>
 ##	Execute the master postdrop in the
-##	postfix postdrop domain.
+##	postfix_postdrop domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -458,14 +461,13 @@ interface(`postfix_domtrans_postdrop',`
 		type postfix_postdrop_t, postfix_postdrop_exec_t;
 	')
 
-	corecmd_search_bin($1)
 	domtrans_pattern($1, postfix_postdrop_exec_t, postfix_postdrop_t)
 ')
 
 ########################################
 ## <summary>
 ##	Execute the master postqueue in the
-##	postfix postqueue domain.
+##	postfix_postqueue domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -478,30 +480,85 @@ interface(`postfix_domtrans_postqueue',`
 		type postfix_postqueue_t, postfix_postqueue_exec_t;
 	')
 
-	corecmd_search_bin($1)
 	domtrans_pattern($1, postfix_postqueue_exec_t, postfix_postqueue_t)
 ')
 
-#######################################
+########################################
 ## <summary>
-##	Execute the master postqueue in
-##	the caller domain.  (Deprecated)
+##	Execute the master postqueue in the
+##	postfix_postdrop domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain allowed access.
+##	Domain allowed to transition.
+##	</summary>
+## </param>
+## <param name="role">
+##  <summary>
+##  The role to be allowed the iptables domain.
+##  </summary>
+## </param>
+## <rolecap/>
+#
+
+interface(`postfix_run_postqueue',`
+	gen_require(`
+		type postfix_postqueue_t;
+	')
+
+	postfix_domtrans_postqueue($1)
+	role $2 types postfix_postqueue_t;
+	allow postfix_postqueue_t $1:unix_stream_socket { read write getattr };
+')
+
+########################################
+## <summary>
+##	Execute postfix_postgqueue in the postfix_postgqueue domain.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed to transition.
+##	</summary>
+## </param>
+#
+interface(`postfix_domtrans_postgqueue',`
+    gen_require(`
+            type postfix_postgqueue_t;
+            type postfix_postgqueue_exec_t;
+    ')
+        domtrans_pattern($1, postfix_postgqueue_exec_t,postfix_postgqueue_t)
+')
+
+########################################
+## <summary>
+##	Execute postfix_postgqueue in the postfix_postgqueue domain, and
+##	allow the specified role the postfix_postgqueue domain.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed to transition.
+##	</summary>
+## </param>
+## <param name="role">
+##	<summary>
+##	Role allowed access.
 ##	</summary>
 ## </param>
+## <rolecap/>
 #
-interface(`posftix_exec_postqueue',`
-	refpolicywarn(`$0($*) has been deprecated.')
-	postfix_exec_postqueue($1)
+interface(`postfix_run_postgqueue',`
+	gen_require(`
+		type postfix_postgqueue_t;
+	')
+
+	postfix_domtrans_postgqueue($1)
+	role $2 types postfix_postgqueue_t;
 ')
 
+
 #######################################
 ## <summary>
-##	Execute postfix postqueue in
-##	the caller domain.
+##	Execute the master postqueue in the caller domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -514,13 +571,12 @@ interface(`postfix_exec_postqueue',`
 		type postfix_postqueue_exec_t;
 	')
 
-	corecmd_search_bin($1)
 	can_exec($1, postfix_postqueue_exec_t)
 ')
 
 ########################################
 ## <summary>
-##	Create postfix private sock files.
+##	Create a named socket in a postfix private directory.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -533,13 +589,13 @@ interface(`postfix_create_private_socket
 		type postfix_private_t;
 	')
 
+	allow $1 postfix_private_t:dir list_dir_perms;
 	create_sock_files_pattern($1, postfix_private_t, postfix_private_t)
 ')
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	postfix private sock files.
+##	manage named socket in a postfix private directory.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -552,13 +608,14 @@ interface(`postfix_manage_private_socket
 		type postfix_private_t;
 	')
 
+	allow $1 postfix_private_t:dir list_dir_perms;
 	manage_sock_files_pattern($1, postfix_private_t, postfix_private_t)
 ')
 
 ########################################
 ## <summary>
-##	Execute the smtp postfix program
-##	in the postfix smtp domain.
+##	Execute the master postfix program in the
+##	postfix_master domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -571,14 +628,12 @@ interface(`postfix_domtrans_smtp',`
 		type postfix_smtp_t, postfix_smtp_exec_t;
 	')
 
-	corecmd_search_bin($1)
 	domtrans_pattern($1, postfix_smtp_exec_t, postfix_smtp_t)
 ')
 
 ########################################
 ## <summary>
-##	Get attributes of all postfix mail
-##	spool files.
+##	Getattr postfix mail spool files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -586,7 +641,7 @@ interface(`postfix_domtrans_smtp',`
 ##	</summary>
 ## </param>
 #
-interface(`postfix_getattr_all_spool_files',`
+interface(`postfix_getattr_spool_files',`
 	gen_require(`
 		attribute postfix_spool_type;
 	')
@@ -607,11 +662,11 @@ interface(`postfix_getattr_all_spool_fil
 #
 interface(`postfix_search_spool',`
 	gen_require(`
-		type postfix_spool_t;
+		attribute postfix_spool_type;
 	')
 
+	allow $1 postfix_spool_type:dir search_dir_perms;
 	files_search_spool($1)
-	allow $1 postfix_spool_t:dir search_dir_perms;
 ')
 
 ########################################
@@ -626,11 +681,11 @@ interface(`postfix_search_spool',`
 #
 interface(`postfix_list_spool',`
 	gen_require(`
-		type postfix_spool_t;
+		attribute postfix_spool_type;
 	')
 
+	allow $1 postfix_spool_type:dir list_dir_perms;
 	files_search_spool($1)
-	allow $1 postfix_spool_t:dir list_dir_perms;
 ')
 
 ########################################
@@ -645,17 +700,16 @@ interface(`postfix_list_spool',`
 #
 interface(`postfix_read_spool_files',`
 	gen_require(`
-		type postfix_spool_t;
+		attribute postfix_spool_type;
 	')
 
 	files_search_spool($1)
-	read_files_pattern($1, postfix_spool_t, postfix_spool_t)
+	read_files_pattern($1, postfix_spool_type, postfix_spool_type)
 ')
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	postfix mail spool files.
+##	Create, read, write, and delete postfix mail spool files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -665,11 +719,50 @@ interface(`postfix_read_spool_files',`
 #
 interface(`postfix_manage_spool_files',`
 	gen_require(`
-		type postfix_spool_t;
+		attribute postfix_spool_type;
 	')
 
 	files_search_spool($1)
-	manage_files_pattern($1, postfix_spool_t, postfix_spool_t)
+	manage_files_pattern($1, postfix_spool_type, postfix_spool_type)
+')
+
+#######################################
+## <summary>
+##  Read, write, and delete postfix maildrop spool files.
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed access.
+##  </summary>
+## </param>
+#
+interface(`postfix_rw_spool_maildrop_files',`
+    gen_require(`
+        type postfix_spool_maildrop_t;
+    ')
+
+    files_search_spool($1)
+    rw_files_pattern($1, postfix_spool_maildrop_t, postfix_spool_maildrop_t)
+')
+
+#######################################
+## <summary>
+##  Create, read, write, and delete postfix maildrop spool files.
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed access.
+##  </summary>
+## </param>
+#
+interface(`postfix_manage_spool_maildrop_files',`
+    gen_require(`
+        type postfix_spool_maildrop_t;
+    ')
+
+    files_search_spool($1)
+    manage_dirs_pattern($1, postfix_spool_maildrop_t, postfix_spool_maildrop_t)
+    manage_files_pattern($1, postfix_spool_maildrop_t, postfix_spool_maildrop_t)
 ')
 
 ########################################
@@ -693,8 +786,8 @@ interface(`postfix_domtrans_user_mail_ha
 
 ########################################
 ## <summary>
-##	All of the rules required to
-##	administrate an postfix environment.
+##	All of the rules required to administrate
+##	an postfix environment.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -710,38 +803,137 @@ interface(`postfix_domtrans_user_mail_ha
 #
 interface(`postfix_admin',`
 	gen_require(`
-		attribute postfix_domain, postfix_spool_type, postfix_server_tmp_content;
-		type postfix_initrc_exec_t, postfix_prng_t, postfix_etc_t;
-		type postfix_data_t, postfix_var_run_t, postfix_public_t;
-		type postfix_private_t, postfix_map_tmp_t, postfix_exec_t;
-		type postfix_keytab_t;
+		attribute postfix_spool_type;
+		type postfix_bounce_t, postfix_cleanup_t, postfix_local_t;
+		type postfix_master_t, postfix_pickup_t, postfix_qmgr_t;
+		type postfix_initrc_exec_t, postfix_data_t, postfix_etc_t;
+		type postfix_map_tmp_t, postfix_prng_t, postfix_public_t;
+		type postfix_smtpd_t, postfix_var_run_t;
+	')
+
+	allow $1 postfix_bounce_t:process signal_perms;
+	ps_process_pattern($1, postfix_bounce_t)
+	tunable_policy(`deny_ptrace',`',`
+		allow $1 postfix_bounce_t:process ptrace;
 	')
 
-	allow $1 postfix_domain:process { ptrace signal_perms };
-	ps_process_pattern($1, postfix_domain)
+	allow $1 postfix_cleanup_t:process signal_perms;
+	ps_process_pattern($1, postfix_cleanup_t)
+	tunable_policy(`deny_ptrace',`',`
+		allow $1 postfix_cleanup_t:process ptrace;
+		allow $1 postfix_local_t:process ptrace;
+		allow $1 postfix_master_t:process ptrace;
+		allow $1 postfix_pickup_t:process ptrace;
+		allow $1 postfix_qmgr_t:process ptrace;
+		allow $1 postfix_smtpd_t:process ptrace;
+	')
 
-	init_labeled_script_domtrans($1, postfix_initrc_exec_t)
+	allow $1 postfix_local_t:process signal_perms;
+	ps_process_pattern($1, postfix_local_t)
+
+	allow $1 postfix_master_t:process signal_perms;
+	ps_process_pattern($1, postfix_master_t)
+
+	allow $1 postfix_pickup_t:process signal_perms;
+	ps_process_pattern($1, postfix_pickup_t)
+
+	allow $1 postfix_qmgr_t:process signal_perms;
+	ps_process_pattern($1, postfix_qmgr_t)
+
+	allow $1 postfix_smtpd_t:process signal_perms;
+	ps_process_pattern($1, postfix_smtpd_t)
+
+	postfix_run_map($1, $2)
+	postfix_run_postdrop($1, $2)
+	postfix_run_postqueue($1, $2)
+
+	postfix_initrc_domtrans($1)
 	domain_system_change_exemption($1)
 	role_transition $2 postfix_initrc_exec_t system_r;
 	allow $2 system_r;
 
-	files_search_etc($1)
-	admin_pattern($1, { postfix_prng_t postfix_etc_t postfix_exec_t postfix_keytab_t })
+	admin_pattern($1, postfix_data_t) 
 
-	files_search_spool($1)
-	admin_pattern($1, { postfix_public_t postfix_private_t postfix_spool_type })
+	files_list_etc($1)
+	admin_pattern($1, postfix_etc_t)
 
-	files_search_var_lib($1)
-	admin_pattern($1, postfix_data_t)
+	files_list_spool($1)
+	admin_pattern($1, postfix_spool_type)
 
-	files_search_pids($1)
 	admin_pattern($1, postfix_var_run_t)
 
-	files_search_tmp($1)
-	admin_pattern($1, { postfix_server_tmp_content postfix_map_tmp_t })
+	files_list_tmp($1)
+	admin_pattern($1, postfix_map_tmp_t)
+	
+	admin_pattern($1, postfix_prng_t)
 
-	postfix_exec_master($1)
-	postfix_exec_postqueue($1)
-	postfix_stream_connect_master($1)
-	postfix_run_map($1, $2)
+	admin_pattern($1, postfix_public_t)
+
+	postfix_filetrans_named_content($1)
+')
+
+########################################
+## <summary>
+##	Execute the master postdrop in the
+##	postfix_postdrop domain.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed to transition.
+##	</summary>
+## </param>
+## <param name="role">
+##  <summary>
+##  The role to be allowed the iptables domain.
+##  </summary>
+## </param>
+## <rolecap/>
+#
+interface(`postfix_run_postdrop',`
+	gen_require(`
+		type postfix_postdrop_t;
+	')
+
+	postfix_domtrans_postdrop($1)
+	role $2 types postfix_postdrop_t;
+	allow postfix_postdrop_t $1:unix_stream_socket { read write getattr };
+')
+
+
+########################################
+## <summary>
+##	Execute postfix exec in the users domain
+## </summary>
+## <param name="domain">
+##	<summary>
+##      Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`postfix_exec',`
+	gen_require(`
+		type postfix_exec_t;
+	')
+
+	can_exec($1, postfix_exec_t)
+')
+
+########################################
+## <summary>
+##	Transition to postfix named content
+## </summary>
+## <param name="domain">
+##	<summary>
+##      Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`postfix_filetrans_named_content',`
+	gen_require(`
+		type postfix_exec_t;
+		type postfix_prng_t;
+	')
+
+	postfix_config_filetrans($1, postfix_exec_t, file, "postfix-script")
+	postfix_config_filetrans($1, postfix_prng_t, file, "prng_exch")
 ')
Index: serefpolicy-contrib-20140730/postfixpolicyd.if
===================================================================
--- serefpolicy-contrib-20140730.orig/postfixpolicyd.if
+++ serefpolicy-contrib-20140730/postfixpolicyd.if
@@ -23,8 +23,11 @@ interface(`postfixpolicyd_admin',`
 		type postfix_policyd_var_run_t, postfix_policyd_initrc_exec_t;
 	')
 
-	allow $1 postfix_policyd_t:process { ptrace signal_perms };
+	allow $1 postfix_policyd_t:process signal_perms;
 	ps_process_pattern($1, postfix_policyd_t)
+	tunable_policy(`deny_ptrace',`',`
+		allow $1 postfix_policyd_t:process ptrace;
+	')
 
 	init_labeled_script_domtrans($1, postfix_policyd_initrc_exec_t)
 	domain_system_change_exemption($1)
Index: serefpolicy-contrib-20140730/postfixpolicyd.te
===================================================================
--- serefpolicy-contrib-20140730.orig/postfixpolicyd.te
+++ serefpolicy-contrib-20140730/postfixpolicyd.te
@@ -34,7 +34,6 @@ allow postfix_policyd_t postfix_policyd_
 manage_files_pattern(postfix_policyd_t, postfix_policyd_var_run_t, postfix_policyd_var_run_t)
 files_pid_filetrans(postfix_policyd_t, postfix_policyd_var_run_t, file)
 
-corenet_all_recvfrom_unlabeled(postfix_policyd_t)
 corenet_tcp_sendrecv_generic_if(postfix_policyd_t)
 corenet_tcp_sendrecv_generic_node(postfix_policyd_t)
 corenet_tcp_bind_generic_node(postfix_policyd_t)
@@ -47,11 +46,7 @@ corenet_sendrecv_mysqld_server_packets(p
 corenet_tcp_bind_mysqld_port(postfix_policyd_t)
 corenet_tcp_sendrecv_mysqld_port(postfix_policyd_t)
 
-files_read_etc_files(postfix_policyd_t)
-files_read_usr_files(postfix_policyd_t)
 
 logging_send_syslog_msg(postfix_policyd_t)
 
-miscfiles_read_localization(postfix_policyd_t)
-
 sysnet_dns_name_resolve(postfix_policyd_t)
